diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/test/ipv4-global-routing-test-suite.cc ns-3.45/src/internet/test/ipv4-global-routing-test-suite.cc
--- ns-3.44/src/internet/test/ipv4-global-routing-test-suite.cc	2025-03-09 16:55:49.411371200 -0700
+++ ns-3.45/src/internet/test/ipv4-global-routing-test-suite.cc	2025-06-01 20:34:45.333701400 -0700
@@ -875,8 +875,8 @@
     : TestCase("Dynamic global routing example"),
       m_count(0)
 {
-    m_firstInterface.resize(16);
-    m_secondInterface.resize(16);
+    m_firstInterface.resize(16, 0);
+    m_secondInterface.resize(16, 0);
     m_dataRate = DataRate("2kbps");
     m_packetSize = 50;
 }
@@ -988,11 +988,11 @@
 
     devHelper.SetNetDevicePointToPointMode(true);
     NetDeviceContainer d0d2 = devHelper.Install(n0n2);
-    devHelper.SetNetDevicePointToPointMode(false);
-
     NetDeviceContainer d1d6 = devHelper.Install(n1n6);
     NetDeviceContainer d1d2 = devHelper.Install(n1n2);
     NetDeviceContainer d5d6 = devHelper.Install(n5n6);
+
+    devHelper.SetNetDevicePointToPointMode(false);
     NetDeviceContainer d2345 = devHelper.Install(n2345);
 
     // Later, we add IP addresses.
@@ -1071,69 +1071,45 @@
     Simulator::Run();
 
     NS_TEST_ASSERT_MSG_EQ(m_count, 70, "Dynamic global routing did not deliver all packets");
-    // Test that for node n6, the interface facing n5 receives packets at
+    // Test that for node n6, the interface facing n1 receives packets at
     // times (1-2), (4-6), (8-10), (11-12), (14-16) and the interface
-    // facing n1 receives packets at times (2-4), (6-8), (12-13)
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[1],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[1]));
-    NS_TEST_ASSERT_MSG_EQ(m_secondInterface[2],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_secondInterface[2]));
-    NS_TEST_ASSERT_MSG_EQ(m_secondInterface[3],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_secondInterface[3]));
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[4],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[4]));
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[5],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[5]));
-    NS_TEST_ASSERT_MSG_EQ(m_secondInterface[6],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_secondInterface[6]));
-    NS_TEST_ASSERT_MSG_EQ(m_secondInterface[7],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_secondInterface[7]));
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[8],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[8]));
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[9],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[9]));
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[10],
-                          0,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[10]));
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[11],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[11]));
-    NS_TEST_ASSERT_MSG_EQ(m_secondInterface[12],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_secondInterface[12]));
-    NS_TEST_ASSERT_MSG_EQ(m_secondInterface[13],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_secondInterface[13]));
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[14],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[14]));
-    NS_TEST_ASSERT_MSG_EQ(m_firstInterface[15],
-                          5,
-                          "Dynamic global routing did not deliver all packets "
-                              << int(m_firstInterface[15]));
+    // facing n5 receives packets at times (2-4), (6-8), (12-13)
+
+    // Note: there are two sending sockets, both on n1.
+    // The first socket sends packets at time (1-10), the second at time (11, 16).
+    // The first socket sends packets to n6, targeting the address facing n5.
+    // The second socket sends packets to n6, targeting the address facing n1.
+    // This actually doesn't matter, as n6 will accept packets sent to the "wrong" address.
+    //
+    // The shortest path netween n1 and n6 is the direct one, but the topology changes during the
+    // simulation:
+    // - (2-4): removal from n1 of the interface toward n6
+    // - (6-8): removal from n6 of the interface toward n1
+    // - (12-14): removal from n1 of the interface toward n6
+    // When the link is broken, packets are rerouted though the longest (and only) path, reaching
+    // n6 though n5.
+
+    std::vector<uint8_t> firstInterfaceTest{0, 5, 0, 0, 5, 5, 0, 0, 5, 5, 0, 5, 0, 0, 5, 5};
+    std::vector<uint8_t> secondInterfaceTest{0, 0, 5, 5, 0, 0, 5, 5, 0, 0, 0, 0, 5, 5, 0, 0};
+
+    for (uint32_t index = 0; index < firstInterfaceTest.size(); index++)
+    {
+        NS_TEST_ASSERT_MSG_EQ(firstInterfaceTest[index],
+                              m_firstInterface[index],
+                              "Dynamic global routing did deliver the wrong number of packets "
+                              "to the first interface at time "
+                                  << index);
+    }
+
+    for (uint32_t index = 0; index < secondInterfaceTest.size(); index++)
+    {
+        NS_TEST_ASSERT_MSG_EQ(secondInterfaceTest[index],
+                              m_secondInterface[index],
+                              "Dynamic global routing did deliver the wrong number of packets "
+                              "to the second interface at time "
+                                  << index);
+    }
+
     Simulator::Destroy();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/test/ipv4-test.cc ns-3.45/src/internet/test/ipv4-test.cc
--- ns-3.44/src/internet/test/ipv4-test.cc	2025-03-09 16:55:49.411371200 -0700
+++ ns-3.45/src/internet/test/ipv4-test.cc	2025-06-01 20:34:45.333701400 -0700
@@ -8,12 +8,13 @@
  */
 
 #include "ns3/arp-l3-protocol.h"
+#include "ns3/boolean.h"
 #include "ns3/inet-socket-address.h"
 #include "ns3/ipv4-interface.h"
 #include "ns3/ipv4-l3-protocol.h"
 #include "ns3/log.h"
-#include "ns3/loopback-net-device.h"
 #include "ns3/node.h"
+#include "ns3/simple-net-device.h"
 #include "ns3/simulator.h"
 #include "ns3/test.h"
 
@@ -47,12 +48,19 @@
     Ptr<Node> node = CreateObject<Node>();
     Ptr<Ipv4L3Protocol> ipv4 = CreateObject<Ipv4L3Protocol>();
     Ptr<Ipv4Interface> interface = CreateObject<Ipv4Interface>();
-    Ptr<LoopbackNetDevice> device = CreateObject<LoopbackNetDevice>();
+    Ptr<SimpleNetDevice> device = CreateObject<SimpleNetDevice>();
+
+    // The following allows the interface to run without ARP
+    device->SetAttribute("PointToPointMode", BooleanValue(true));
+
     node->AddDevice(device);
+    node->AggregateObject(ipv4);
     interface->SetDevice(device);
     interface->SetNode(node);
+
+    // Interface 0 is the Loopback
     uint32_t index = ipv4->AddIpv4Interface(interface);
-    NS_TEST_ASSERT_MSG_EQ(index, 0, "No interface should be found??");
+    NS_TEST_ASSERT_MSG_EQ(index, 1, "The index is not 1??");
     interface->SetUp();
     Ipv4InterfaceAddress ifaceAddr1 = Ipv4InterfaceAddress("192.168.0.1", "255.255.255.0");
     interface->AddAddress(ifaceAddr1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/test/ipv6-test.cc ns-3.45/src/internet/test/ipv6-test.cc
--- ns-3.44/src/internet/test/ipv6-test.cc	2025-03-09 16:55:49.411371200 -0700
+++ ns-3.45/src/internet/test/ipv6-test.cc	2025-06-01 20:34:45.334701300 -0700
@@ -164,7 +164,7 @@
     NS_TEST_ASSERT_MSG_EQ(num, 1, "Number of addresses should be 1??");
 
     Simulator::Destroy();
-} // end DoRun
+}
 
 /**
  * @ingroup internet-test
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/CMakeLists.txt ns-3.45/src/internet-apps/CMakeLists.txt
--- ns-3.44/src/internet-apps/CMakeLists.txt	2025-03-09 16:55:49.379371200 -0700
+++ ns-3.45/src/internet-apps/CMakeLists.txt	2025-06-01 20:34:45.313701200 -0700
@@ -2,12 +2,18 @@
   LIBNAME internet-apps
   SOURCE_FILES
     helper/dhcp-helper.cc
+    helper/dhcp6-helper.cc
     helper/ping-helper.cc
     helper/radvd-helper.cc
     helper/v4traceroute-helper.cc
     model/dhcp-client.cc
     model/dhcp-header.cc
     model/dhcp-server.cc
+    model/dhcp6-client.cc
+    model/dhcp6-duid.cc
+    model/dhcp6-header.cc
+    model/dhcp6-options.cc
+    model/dhcp6-server.cc
     model/ping.cc
     model/radvd-interface.cc
     model/radvd-prefix.cc
@@ -15,12 +21,18 @@
     model/v4traceroute.cc
   HEADER_FILES
     helper/dhcp-helper.h
+    helper/dhcp6-helper.h
     helper/ping-helper.h
     helper/radvd-helper.h
     helper/v4traceroute-helper.h
     model/dhcp-client.h
     model/dhcp-header.h
     model/dhcp-server.h
+    model/dhcp6-client.h
+    model/dhcp6-duid.h
+    model/dhcp6-header.h
+    model/dhcp6-options.h
+    model/dhcp6-server.h
     model/ping.h
     model/radvd-interface.h
     model/radvd-prefix.h
@@ -29,6 +41,7 @@
   LIBRARIES_TO_LINK ${libinternet}
   TEST_SOURCES
     test/dhcp-test.cc
+    test/dhcp6-test.cc
     test/ipv6-radvd-test.cc
     test/ping-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/examples/CMakeLists.txt ns-3.45/src/internet-apps/examples/CMakeLists.txt
--- ns-3.44/src/internet-apps/examples/CMakeLists.txt	2025-03-09 16:55:49.379371200 -0700
+++ ns-3.45/src/internet-apps/examples/CMakeLists.txt	2025-06-01 20:34:45.313701200 -0700
@@ -10,6 +10,18 @@
 )
 
 build_lib_example(
+  NAME dhcp6-example
+  SOURCE_FILES dhcp6-example.cc
+  LIBRARIES_TO_LINK
+    ${libapplications}
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+    ${libpoint-to-point}
+    ${libwifi}
+)
+
+build_lib_example(
   NAME traceroute-example
   SOURCE_FILES traceroute-example.cc
   LIBRARIES_TO_LINK
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/examples/dhcp6-example.cc ns-3.45/src/internet-apps/examples/dhcp6-example.cc
--- ns-3.44/src/internet-apps/examples/dhcp6-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/internet-apps/examples/dhcp6-example.cc	2025-06-01 20:34:45.313701200 -0700
@@ -0,0 +1,215 @@
+/*
+ * Copyright (c) 2024 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Kavya Bhat <kavyabhat@gmail.com>
+ *
+ */
+
+/*
+ * Network layout:
+ * The following devices have one CSMA interface each -
+ * S0 - DHCPv6 server
+ * N0, N1 - DHCPv6 clients
+ * R0 - router
+ *                ┌-------------------------------------------------┐
+ *                | DHCPv6 Clients                                  |
+ *                |                                                 |
+ *                |                                Static address   |
+ *                |                                2001:cafe::42:2  |
+ *                |   ┌──────┐       ┌──────┐        ┌──────┐       |
+ *                |   │  N0  │       │  N1  │        │  N2  │       |
+ *                |   └──────┘       └──────┘        └──────┘       |
+ *                |       │              │               │          |
+ *                └-------│--------------│---------------│----------┘
+ *  DHCPv6 Server         │              │               │
+ *        ┌──────┐        │              │               │      ┌──────┐
+ *        │  S0  │────────┴──────────────┴───────────────┴──────│  R0  │Router
+ *        └──────┘                                              └──────┘
+ * Notes:
+ * 1. The DHCPv6 server is not assigned any static address as it operates only
+ *    in the link-local domain.
+ * 2. N2 has a statically assigned address to demonstrate the operation of the
+ *    DHCPv6 Decline message.
+ * 3. The server is usually on the router in practice, but we demonstrate in
+ *    this example a standalone server.
+ * 4. Linux uses fairly large values for address lifetimes (in thousands of
+ *    seconds). In this example, we have set shorter lifetimes for the purpose
+ *    of observing the Renew messages within a shorter simulation run.
+ * 5. The nodes use two interfaces each for the purpose of demonstrating
+ *    DHCPv6 operation when multiple interfaces are present on the client or
+ *    server nodes.
+ *
+ * This example demonstrates how to set up a simple DHCPv6 server and two DHCPv6
+ * clients. The clients begin to request an address lease using a Solicit
+ * message only after receiving a Router Advertisement containing the 'M' bit
+ * from the router, R0.
+ *
+ * The server responds with an Advertise message with all available address
+ * offers, and the client sends a Request message to the server for these
+ * addresses. The server then sends a Reply message to the client, which
+ * performs Duplicate Address Detection to check if any other node on the link
+ * already uses this address.
+ * If the address is in use by any other node, the client sends a Decline
+ * message to the server. If the address is not in use, the client begins using
+ * this address.
+ * At the end of the address lease lifetime, the client sends a Renew message
+ * to the server, which renews the lease and allows the client to continue using
+ * the same address.
+ *
+ * The user may enable packet traces in this example to observe the following
+ * message exchanges:
+ * 1. Solicit - Advertise - Request - Reply
+ * 2. Solicit - Advertise - Request - Reply - Decline
+ * 3. Renew - Reply
+ *
+ */
+
+#include "ns3/applications-module.h"
+#include "ns3/core-module.h"
+#include "ns3/csma-module.h"
+#include "ns3/internet-apps-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/mobility-module.h"
+#include "ns3/network-module.h"
+#include "ns3/point-to-point-module.h"
+#include "ns3/ssid.h"
+#include "ns3/wifi-helper.h"
+#include "ns3/yans-wifi-helper.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("Dhcp6Example");
+
+void
+SetInterfaceDown(Ptr<Node> node, uint32_t interface)
+{
+    node->GetObject<Ipv6>()->SetDown(interface);
+}
+
+void
+SetInterfaceUp(Ptr<Node> node, uint32_t interface)
+{
+    node->GetObject<Ipv6>()->SetUp(interface);
+}
+
+int
+main(int argc, char* argv[])
+{
+    CommandLine cmd(__FILE__);
+
+    bool verbose = false;
+    bool enablePcap = false;
+    cmd.AddValue("verbose", "Turn on the logs", verbose);
+    cmd.AddValue("enablePcap", "Enable/Disable pcap file generation", enablePcap);
+
+    cmd.Parse(argc, argv);
+    GlobalValue::Bind("ChecksumEnabled", BooleanValue(true));
+
+    if (verbose)
+    {
+        LogComponentEnable("Dhcp6Server", LOG_LEVEL_INFO);
+        LogComponentEnable("Dhcp6Client", LOG_LEVEL_INFO);
+    }
+
+    Time stopTime = Seconds(25.0);
+
+    NS_LOG_INFO("Create nodes.");
+    NodeContainer nonRouterNodes;
+    nonRouterNodes.Create(4);
+    Ptr<Node> router = CreateObject<Node>();
+    NodeContainer all(nonRouterNodes, router);
+
+    NS_LOG_INFO("Create channels.");
+    CsmaHelper csma;
+    csma.SetChannelAttribute("DataRate", StringValue("5Mbps"));
+    csma.SetChannelAttribute("Delay", StringValue("2ms"));
+    NetDeviceContainer devices = csma.Install(all); // all nodes
+
+    InternetStackHelper internetv6;
+    internetv6.Install(all);
+
+    NS_LOG_INFO("Create networks and assign IPv6 Addresses.");
+
+    Ipv6AddressHelper ipv6;
+    ipv6.SetBase(Ipv6Address("2001:cafe::"), Ipv6Prefix(64));
+    NetDeviceContainer nonRouterDevices;
+    nonRouterDevices.Add(devices.Get(0)); // The server node, S0.
+    nonRouterDevices.Add(devices.Get(1)); // The first client node, N0.
+    nonRouterDevices.Add(devices.Get(2)); // The second client node, N1.
+    nonRouterDevices.Add(devices.Get(3)); // The third client node, N2.
+    Ipv6InterfaceContainer i = ipv6.AssignWithoutAddress(nonRouterDevices);
+
+    NS_LOG_INFO("Assign static IP address to the third node.");
+    Ptr<Ipv6> ipv6proto = nonRouterNodes.Get(3)->GetObject<Ipv6>();
+    int32_t ifIndex = ipv6proto->GetInterfaceForDevice(devices.Get(3));
+    Ipv6InterfaceAddress ipv6Addr =
+        Ipv6InterfaceAddress(Ipv6Address("2001:cafe::42:2"), Ipv6Prefix(128));
+    ipv6proto->AddAddress(ifIndex, ipv6Addr);
+
+    NS_LOG_INFO("Assign static IP address to the router node.");
+    NetDeviceContainer routerDevice;
+    routerDevice.Add(devices.Get(4)); // CSMA interface of the node R0.
+    Ipv6InterfaceContainer r1 = ipv6.Assign(routerDevice);
+    r1.SetForwarding(0, true);
+
+    NS_LOG_INFO("Create Radvd applications.");
+    RadvdHelper radvdHelper;
+
+    /* Set up unsolicited RAs */
+    radvdHelper.AddAnnouncedPrefix(r1.GetInterfaceIndex(0), Ipv6Address("2001:cafe::1"), 64);
+    radvdHelper.GetRadvdInterface(r1.GetInterfaceIndex(0))->SetManagedFlag(true);
+
+    NS_LOG_INFO("Create DHCP applications.");
+    Dhcp6Helper dhcp6Helper;
+
+    NS_LOG_INFO("Set timers to desired values.");
+    dhcp6Helper.SetServerAttribute("RenewTime", StringValue("10s"));
+    dhcp6Helper.SetServerAttribute("RebindTime", StringValue("16s"));
+    dhcp6Helper.SetServerAttribute("PreferredLifetime", StringValue("18s"));
+    dhcp6Helper.SetServerAttribute("ValidLifetime", StringValue("20s"));
+
+    // DHCPv6 clients
+    NodeContainer nodes = NodeContainer(nonRouterNodes.Get(1), nonRouterNodes.Get(2));
+    ApplicationContainer dhcpClients = dhcp6Helper.InstallDhcp6Client(nodes);
+    dhcpClients.Start(Seconds(1.0));
+    dhcpClients.Stop(stopTime);
+
+    // DHCP server
+    NetDeviceContainer serverNetDevices;
+    serverNetDevices.Add(nonRouterDevices.Get(0));
+    ApplicationContainer dhcpServerApp = dhcp6Helper.InstallDhcp6Server(serverNetDevices);
+
+    Ptr<Dhcp6Server> server = DynamicCast<Dhcp6Server>(dhcpServerApp.Get(0));
+    server->AddSubnet(Ipv6Address("2001:cafe::"),
+                      Ipv6Prefix(64),
+                      Ipv6Address("2001:cafe::42:1"),
+                      Ipv6Address("2001:cafe::42:ffff"));
+
+    dhcpServerApp.Start(Seconds(0.0));
+    dhcpServerApp.Stop(stopTime);
+
+    ApplicationContainer radvdApps = radvdHelper.Install(router);
+    radvdApps.Start(Seconds(1.0));
+    radvdApps.Stop(stopTime);
+
+    Simulator::Stop(stopTime + Seconds(2.0));
+
+    // Schedule N0 interface to go down and come up to see the effects of
+    // link state change.
+    Simulator::Schedule(Seconds(4), &SetInterfaceDown, nonRouterNodes.Get(1), 1);
+    Simulator::Schedule(Seconds(5), &SetInterfaceUp, nonRouterNodes.Get(1), 1);
+
+    if (enablePcap)
+    {
+        csma.EnablePcapAll("dhcp6-csma");
+    }
+
+    NS_LOG_INFO("Run Simulation.");
+    Simulator::Run();
+
+    NS_LOG_INFO("Done.");
+    Simulator::Destroy();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/helper/dhcp6-helper.cc ns-3.45/src/internet-apps/helper/dhcp6-helper.cc
--- ns-3.44/src/internet-apps/helper/dhcp6-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/internet-apps/helper/dhcp6-helper.cc	2025-06-01 20:34:45.314701300 -0700
@@ -0,0 +1,117 @@
+/*
+ * Copyright (c) 2024 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Kavya Bhat <kavyabhat@gmail.com>
+ *
+ */
+
+#include "dhcp6-helper.h"
+
+#include "ns3/dhcp6-client.h"
+#include "ns3/dhcp6-server.h"
+#include "ns3/ipv6.h"
+#include "ns3/log.h"
+#include "ns3/loopback-net-device.h"
+#include "ns3/names.h"
+#include "ns3/uinteger.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("Dhcp6Helper");
+
+Dhcp6Helper::Dhcp6Helper()
+{
+    m_clientFactory.SetTypeId(Dhcp6Client::GetTypeId());
+    m_serverFactory.SetTypeId(Dhcp6Server::GetTypeId());
+}
+
+void
+Dhcp6Helper::SetClientAttribute(std::string name, const AttributeValue& value)
+{
+    m_clientFactory.Set(name, value);
+}
+
+void
+Dhcp6Helper::SetServerAttribute(std::string name, const AttributeValue& value)
+{
+    m_serverFactory.Set(name, value);
+}
+
+ApplicationContainer
+Dhcp6Helper::InstallDhcp6Client(NodeContainer clientNodes) const
+{
+    ApplicationContainer installedApps;
+    for (auto iter = clientNodes.Begin(); iter != clientNodes.End(); iter++)
+    {
+        Ptr<Application> app = InstallDhcp6ClientInternal((*iter));
+        installedApps.Add(app);
+    }
+
+    return installedApps;
+}
+
+ApplicationContainer
+Dhcp6Helper::InstallDhcp6Server(NetDeviceContainer netDevices)
+{
+    ApplicationContainer installedApps;
+    for (auto itr = netDevices.Begin(); itr != netDevices.End(); itr++)
+    {
+        Ptr<NetDevice> netDevice = *itr;
+        Ptr<Node> node = netDevice->GetNode();
+        NS_ASSERT_MSG(node, "Dhcp6Helper: NetDevice is not associated with any node -> fail");
+
+        Ptr<Ipv6> ipv6 = node->GetObject<Ipv6>();
+        NS_ASSERT_MSG(ipv6,
+                      "Dhcp6Helper: NetDevice is associated"
+                      " with a node without IPv6 stack installed -> fail "
+                      "(maybe need to use InternetStackHelper?)");
+
+        uint32_t nApplications = node->GetNApplications();
+
+        for (uint32_t i = 0; i < nApplications; i++)
+        {
+            Ptr<Dhcp6Server> server = DynamicCast<Dhcp6Server>(node->GetApplication(i));
+            if (!server)
+            {
+                Ptr<Dhcp6Server> app = m_serverFactory.Create<Dhcp6Server>();
+                node->AddApplication(app);
+                app->SetDhcp6ServerNetDevice(netDevices);
+                installedApps.Add(app);
+            }
+        }
+
+        if (nApplications == 0)
+        {
+            Ptr<Dhcp6Server> app = m_serverFactory.Create<Dhcp6Server>();
+            node->AddApplication(app);
+            app->SetDhcp6ServerNetDevice(netDevices);
+            installedApps.Add(app);
+        }
+    }
+
+    return installedApps;
+}
+
+Ptr<Application>
+Dhcp6Helper::InstallDhcp6ClientInternal(Ptr<Node> clientNode) const
+{
+    Ptr<Application> app;
+    for (uint32_t index = 0; index < clientNode->GetNApplications(); index++)
+    {
+        app = clientNode->GetApplication(index);
+        if (app->GetInstanceTypeId() == Dhcp6Client::GetTypeId())
+        {
+            return app;
+        }
+    }
+
+    app = m_clientFactory.Create<Dhcp6Client>();
+    clientNode->AddApplication(app);
+
+    return app;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/helper/dhcp6-helper.h ns-3.45/src/internet-apps/helper/dhcp6-helper.h
--- ns-3.44/src/internet-apps/helper/dhcp6-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/internet-apps/helper/dhcp6-helper.h	2025-06-01 20:34:45.314701300 -0700
@@ -0,0 +1,89 @@
+/*
+ * Copyright (c) 2024 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Kavya Bhat <kavyabhat@gmail.com>
+ *
+ */
+
+#ifndef DHCP6_HELPER_H
+#define DHCP6_HELPER_H
+
+#include "ns3/application-container.h"
+#include "ns3/dhcp6-server.h"
+#include "ns3/ipv6-address.h"
+#include "ns3/ipv6-interface-container.h"
+#include "ns3/net-device-container.h"
+#include "ns3/node-container.h"
+#include "ns3/object-factory.h"
+
+#include <stdint.h>
+
+namespace ns3
+{
+
+/**
+ * @ingroup dhcp6
+ *
+ * @class Dhcp6Helper
+ * @brief The helper class used to configure and install DHCPv6 applications on nodes
+ */
+class Dhcp6Helper
+{
+  public:
+    /**
+     * @brief Default constructor.
+     */
+    Dhcp6Helper();
+
+    /**
+     * @brief Set DHCPv6 client attributes
+     * @param name Name of the attribute
+     * @param value Value to be set
+     */
+    void SetClientAttribute(std::string name, const AttributeValue& value);
+
+    /**
+     * @brief Set DHCPv6 server attributes
+     * @param name Name of the attribute
+     * @param value Value to be set
+     */
+    void SetServerAttribute(std::string name, const AttributeValue& value);
+
+    /**
+     * @brief Install DHCPv6 client on a set of nodes
+     *
+     * If there is already a DHCPv6 client on the node, the app is not installed,
+     * and the already existing one is returned.
+     *
+     * @param clientNodes Nodes on which the DHCPv6 client is installed
+     * @return The application container with DHCPv6 client installed
+     */
+    ApplicationContainer InstallDhcp6Client(NodeContainer clientNodes) const;
+
+    /**
+     * @brief Install DHCPv6 server on a node / NetDevice. Also updates the
+     * interface -> server map.
+     * @param netDevices The NetDevices on which DHCPv6 server application has to be installed
+     * @return The application container with DHCPv6 server installed
+     */
+    ApplicationContainer InstallDhcp6Server(NetDeviceContainer netDevices);
+
+  private:
+    /**
+     * @brief Helper method that iterates through the installed applications
+     * on a node to look for a Dhcp6Client application. It either installs a
+     * new Dhcp6Client or returns an existing one.
+     * @param clientNode The node on which the application is to be installed.
+     * @return Pointer to the Dhcp6Client application on the node.
+     */
+    Ptr<Application> InstallDhcp6ClientInternal(Ptr<Node> clientNode) const;
+
+    ObjectFactory m_clientFactory; //!< DHCPv6 client factory.
+    ObjectFactory m_serverFactory; //!< DHCPv6 server factory.
+};
+
+} // namespace ns3
+
+#endif /* DHCP6_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/helper/radvd-helper.cc ns-3.45/src/internet-apps/helper/radvd-helper.cc
--- ns-3.44/src/internet-apps/helper/radvd-helper.cc	2025-03-09 16:55:49.379371200 -0700
+++ ns-3.45/src/internet-apps/helper/radvd-helper.cc	2025-06-01 20:34:45.314701300 -0700
@@ -27,7 +27,8 @@
 void
 RadvdHelper::AddAnnouncedPrefix(uint32_t interface,
                                 const Ipv6Address& prefix,
-                                uint32_t prefixLength)
+                                uint32_t prefixLength,
+                                bool slaac)
 {
     NS_LOG_FUNCTION(this << int(interface) << prefix << int(prefixLength));
     if (prefixLength != 64)
@@ -59,6 +60,7 @@
     if (!prefixFound)
     {
         Ptr<RadvdPrefix> routerPrefix = Create<RadvdPrefix>(prefix, prefixLength);
+        routerPrefix->SetAutonomousFlag(slaac);
         m_radvdInterfaces[interface]->AddPrefix(routerPrefix);
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/helper/radvd-helper.h ns-3.45/src/internet-apps/helper/radvd-helper.h
--- ns-3.44/src/internet-apps/helper/radvd-helper.h	2025-03-09 16:55:49.379371200 -0700
+++ ns-3.45/src/internet-apps/helper/radvd-helper.h	2025-06-01 20:34:45.314701300 -0700
@@ -35,8 +35,12 @@
      * @param interface outgoing interface
      * @param prefix announced IPv6 prefix
      * @param prefixLength announced IPv6 prefix length
+     * @param slaac available for autoconfiguration
      */
-    void AddAnnouncedPrefix(uint32_t interface, const Ipv6Address& prefix, uint32_t prefixLength);
+    void AddAnnouncedPrefix(uint32_t interface,
+                            const Ipv6Address& prefix,
+                            uint32_t prefixLength,
+                            bool slaac = true);
 
     /**
      * @brief Enable the router as default router for the interface.
